#include <zephyr/kernel.h>
#include <stdio.h>
#include <stdlib.h>

#include "base64_2.h"

const static unsigned char BASE64[64]= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
ssize_t convert_to_base64(uint8_t *datain, ssize_t datain_length, char *dataout) {
  ssize_t dataout_length = 0;
  uint8_t buf[3];
  uint8_t datain_length_remaining;
  for( ssize_t i = 0; i < (datain_length / 3); i++) {
    datain_length_remaining = datain_length - (i * 3);
    //printk("datain_length_remaining = %d\n", datain_length_remaining);

    buf[0] = datain[(i * 3)];
    if(datain_length_remaining >= 1) {
      buf[1] = datain[(i * 3) + 1];
    }
    if(datain_length_remaining >= 2) {
      buf[2] = datain[(i * 3) + 2];
    }

    dataout[dataout_length++] = BASE64[ buf[0] >> 2 ];
    dataout[dataout_length++] = BASE64[(( buf[0] & 3 ) << 4 )|( buf[1] >> 4 )];
    
    if(datain_length_remaining != 1) {
      dataout[dataout_length++] = BASE64[(( buf[1] & 0xf ) << 2 )|( buf[2] >> 6 )];
      if(datain_length_remaining != 2) {
        dataout[dataout_length++] = BASE64[ buf[2] & 0x3f ];
      }
    }

    if(i == 15) {
      //dataout[dataout_length++] = '\n';
    }
  }
  return dataout_length;
}
